package example;

public class Parser extends Lexer {
    
    public Parser (String input)
    {
        super (input);
    }
    
    public Arit factor ()
    {
        Arit result = null;
        if (isSeparator("("))
        {
           nextToken (); // preskocit (
           result = expr ();
           checkSeparator (")");
        }
        else if (kind == ident || kind == number)
        {
           result = new Arit (token);
           nextToken ();
        }
        else
            error ("Identifier or number or sub-expression expected");
        return result;
    }
    
    public Arit term ()
    {
        Arit result = factor ();
        while (isSeparator ("*") || isSeparator ("/"))
        {
            Arit temp = result;
            result = new Arit (token);
            nextToken();
            result.left = temp;
            result.right = factor ();
        }
        return result;
    }
    
    public Arit expr ()
    {
        Arit result = term ();
        while (isSeparator ("+") || isSeparator ("-"))
        {
            Arit temp = result;
            result = new Arit (token);
            nextToken();
            result.left = temp;
            result.right = term ();
        }
        return result;
    }
}
